Index: sasmodels/gen.py
===================================================================
--- sasmodels/gen.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/gen.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -28,26 +28,40 @@
 
 *Iq*, *Iqxy*, *Imagnetic* and *form_volume* should be stylized C-99
-functions written for OpenCL.  Floating point values should be
-declared as *real*.  Depending on how the function is called, a macro
-will replace *real* with *float* or *double*.  Unfortunately, MacOSX
-is picky about floating point constants, which should be defined with
-value + 'f' if they are of type *float* or just a bare value if they
-are of type *double*.  The solution is a macro *REAL(value)* which
-adds the 'f' if compiling for single precision floating point.  This
-does make the code ugly, and may someday be replaced by a clever
-regular expression which does the same job.  OpenCL has a *sincos*
-function which can improve performance when both the *sin* and *cos*
-values are needed for a particular argument.  Since this function
-does not exist in C-99, all use of *sincos* should be replaced by the
-macro *SINCOS(value,sn,cn)* where *sn* and *cn* are previously declared
-*real* values.  *value* may be an expression.  When compiled for systems
-without OpenCL, *SINCOS* will be replaced by *sin* and *cos* calls.  All
-functions need prototype declarations even if the are defined before they
-are used -- another present from MacOSX.  OpenCL does not support
-*#include* preprocessor directives; instead the includes must be listed
-in the kernel metadata, with functions defined before they are used.
-The included files should be listed using relative path to the kernel
-source file, or if using one of the standard models, relative to the
-sasmodels source files.
+functions written for OpenCL.  All functions need prototype declarations
+even if the are defined before they are used.  OpenCL does not support
+*#include* preprocessor directives, so instead the list of includes needs
+to be given as part of the metadata in the kernel module definition.
+The included files should be listed using a path relative to the kernel
+module, or if using "lib/file.c" if it is one of the standard includes
+provided with the sasmodels source.  The includes need to be listed in
+order so that functions are defined before they are used.
+
+Floating point values should be declared as *real*.  Depending on how the
+function is called, a macro will replace *real* with *float* or *double*.
+Unfortunately, MacOSX is picky about floating point constants, which
+should be defined with value + 'f' if they are of type *float* or just
+a bare value if they are of type *double*.  The solution is a macro
+*REAL(value)* which adds the 'f' if compiling for single precision
+floating point.  [Note: we could write a clever regular expression
+which automatically detects real-valued constants.  If we wanted to
+make our code more C-like, we could define variables with double but
+replace them with float before compiling for single precision.]
+
+OpenCL has a *sincos* function which can improve performance when both
+the *sin* and *cos* values are needed for a particular argument.  Since
+this function does not exist in C99, all use of *sincos* should be
+replaced by the macro *SINCOS(value,sn,cn)* where *sn* and *cn* are
+previously declared *real* values.  *value* may be an expression.  When
+compiled for systems without OpenCL, *SINCOS* will be replaced by
+*sin* and *cos* calls.
+
+If the input parameters are invalid, the scattering calculator should
+return a negative number. Particularly with polydispersity, there are
+some sets of shape parameters which lead to nonsensical forms, such
+as a capped cylinder where the cap radius is smaller than the
+cylinder radius.  The polydispersity calculation will ignore these points,
+effectively chopping the parameter weight distributions at the boundary
+of the infeasible region.  The resulting scattering will be set to
+background.  This will work correctly even when polydispersity is off.
 
 *ER* and *VR* are python functions which operate on parameter vectors.
@@ -112,4 +126,8 @@
     *VR* is a python function defining the volume ratio.  If it is not
     present, the volume ratio is 1.
+
+    *form_volume*, *Iq*, *Iqxy*, *Imagnetic* are strings containing the
+    C source code for the body of the volume, Iq, and Iqxy functions
+    respectively.  These can also be defined in the last source file.
 
 An *info* dictionary is constructed from the kernel meta data and
@@ -156,4 +174,6 @@
 __all__ = ["make, doc", "sources"]
 
+import sys
+import os
 import os.path
 
@@ -226,7 +246,7 @@
 #endif
 
-// Standard mathematical constants, prefixed with M_:
-//   E, LOG2E, LOG10E, LN2, LN10, PI, PI_2, PI_4, 1_PI, 2_PI,
-//   2_SQRTPI, SQRT2, SQRT1_2
+// Standard mathematical constants:
+//   M_E, M_LOG2E, M_LOG10E, M_LN2, M_LN10, M_PI, M_PI_2=pi/2, M_PI_4=pi/4,
+//   M_1_PI=1/pi, M_2_PI=2/pi, M_2_SQRTPI=2/sqrt(pi), SQRT2, SQRT1_2=sqrt(1/2)
 // OpenCL defines M_constant_F for float constants, and nothing if double
 // is not enabled on the card, which is why these constants may be missing
@@ -256,4 +276,5 @@
     'qinit': "const real qi = q[i];",
     'qcall': "qi",
+    'qwork': ["q"],
     }
 
@@ -263,4 +284,5 @@
     'qinit': "const real qxi = qx[i];\n    const real qyi = qy[i];",
     'qcall': "qxi, qyi",
+    'qwork': ["qx", "qy"],
     }
 
@@ -318,5 +340,6 @@
 for (int %(name)s_i=0; %(name)s_i < N%(name)s; %(name)s_i++) {
   const real %(name)s = loops[2*(%(name)s_i%(offset)s)];
-  const real %(name)s_w = loops[2*(%(name)s_i%(offset)s)+1];"""
+  const real %(name)s_w = loops[2*(%(name)s_i%(offset)s)+1];\
+"""
 
 # Polydispersity loop body.
@@ -327,8 +350,20 @@
 const real weight = %(weight_product)s;
 if (weight > cutoff) {
-  ret += weight*%(fn)s(%(qcall)s, %(pcall)s);
-  norm += weight;
-  %(volume_norm)s
-}"""
+  const real I = %(fn)s(%(qcall)s, %(pcall)s);
+  if (I>=REAL(0.0)) { // scattering cannot be negative
+    ret += weight*I;
+    norm += weight;
+    %(volume_norm)s
+  }
+  //else { printf("exclude qx,qy,I:%%g,%%g,%%g\\n",%(qcall)s,I); }
+}
+//else { printf("exclude weight:%%g\\n",weight); }\
+"""
+
+# Use this when integrating over orientation
+SPHERICAL_CORRECTION="""\
+// Correction factor for spherical integration p(theta) I(q) sin(theta) dtheta
+real spherical_correction = (Ntheta>1 ? fabs(cos(M_PI_180*phi)) : REAL(1.0));\
+"""
 
 # Volume normalization.
@@ -337,6 +372,16 @@
 # a normalized weight.
 VOLUME_NORM="""const real vol_weight = %(weight)s;
-  vol += vol_weight*form_volume(%(pars)s);
-  norm_vol += vol_weight;"""
+    vol += vol_weight*form_volume(%(pars)s);
+    norm_vol += vol_weight;\
+"""
+
+# functions defined as strings in the .py module
+WORK_FUNCTION="""\
+real %(name)s(%(pars)s);
+real %(name)s(%(pars)s)
+{
+%(body)s
+}\
+"""
 
 # Documentation header for the module, giving the model name, its short
@@ -393,4 +438,5 @@
     vol_pars = info['partype']['volume']
     q_pars = KERNEL_2D if is_2D else KERNEL_1D
+    fn = q_pars['fn']
 
     # Build polydispersity loops
@@ -426,13 +472,19 @@
     fq_pars = [p[0] for p in info['parameters'][len(COMMON_PARAMETERS):]
                if p[0] in set(fixed_pars+pd_pars)]
+    if False and "phi" in pd_pars:
+        spherical_correction = [indent(SPHERICAL_CORRECTION, depth)]
+        weights = [p+"_w" for p in pd_pars]+['spherical_correction']
+    else:
+        spherical_correction = []
+        weights = [p+"_w" for p in pd_pars]
     subst = {
-        'weight_product': "*".join(p+"_w" for p in pd_pars),
+        'weight_product': "*".join(weights),
         'volume_norm': volume_norm,
-        'fn': q_pars['fn'],
+        'fn': fn,
         'qcall': q_pars['qcall'],
         'pcall': ", ".join(fq_pars), # skip scale and background
         }
     loop_body = [indent(LOOP_BODY%subst, depth)]
-    loops = "\n".join(loop_head+loop_body+loop_end)
+    loops = "\n".join(loop_head+spherical_correction+loop_body+loop_end)
 
     # declarations for non-pd followed by pd pars
@@ -465,4 +517,15 @@
         }
     kernel = KERNEL_TEMPLATE%subst
+
+    # If the working function is defined in the kernel metadata as a
+    # string, translate the string to an actual function definition
+    # and put it before the kernel.
+    if info[fn]:
+        subst = {
+            'name': fn,
+            'pars': ", ".join("real "+p for p in q_pars['qwork']+fq_pars),
+            'body': info[fn],
+            }
+        kernel = "\n".join((WORK_FUNCTION%subst, kernel))
     return kernel
 
@@ -514,5 +577,5 @@
     search_path = [ dirname(info['filename']),
                     abspath(joinpath(dirname(__file__),'models')) ]
-    return [_search(search_path) for f in info['source']]
+    return [_search(search_path, f) for f in info['source']]
 
 def make_model(info):
@@ -521,7 +584,18 @@
     found in the given search path.
     """
+    source = [open(f).read() for f in sources(info)]
+    # If the form volume is defined as a string, then wrap it in a
+    # function definition and place it after the external sources but
+    # before the kernel functions.  If the kernel functions are strings,
+    # they will be translated in the make_kernel call.
+    if info['form_volume']:
+        subst = {
+            'name': "form_volume",
+            'pars': ", ".join("real "+p for p in info['partype']['volume']),
+            'body': info['form_volume'],
+            }
+        source.append(WORK_FUNCTION%subst)
     kernel_Iq = make_kernel(info, is_2D=False)
     kernel_Iqxy = make_kernel(info, is_2D=True)
-    source = [open(f).read() for f in sources(info)]
     kernel = "\n\n".join([KERNEL_HEADER]+source+[kernel_Iq, kernel_Iqxy])
     return kernel
@@ -573,10 +647,12 @@
         name = kernel_module.name,
         title = kernel_module.title,
-        source = kernel_module.source,
         description = kernel_module.description,
         parameters = COMMON_PARAMETERS + kernel_module.parameters,
-        ER = getattr(kernel_module, 'ER', None),
-        VR = getattr(kernel_module, 'VR', None),
+        source = getattr(kernel_module, 'source', []),
         )
+    # Fill in attributes which default to None
+    info.update((k,getattr(kernel_module, k, None))
+                for k in ('ER', 'VR', 'form_volume', 'Iq', 'Iqxy'))
+    # Fill in the derived attributes
     info['limits'] = dict((p[0],p[3]) for p in info['parameters'])
     info['partype'] = categorize_parameters(info['parameters'])
@@ -596,65 +672,4 @@
     return DOC_HEADER%subst
 
-# Compiler platform details
-if sys.platform == 'darwin':
-    COMPILE = "gcc-mp-4.7 -shared -fPIC -std=c99 -fopenmp -O2 -Wall %s -o %s -lm -lgomp"
-elif os.name == 'nt':
-    COMPILE = "gcc -shared -fPIC -std=c99 -fopenmp -O2 -Wall %s -o %s -lm"
-else:
-    COMPILE = "cc -shared -fPIC -std=c99 -fopenmp -O2 -Wall %s -o %s -lm"
-DLL_PATH = "/tmp"
-
-
-def dll_path(info):
-    """
-    Path to the compiled model defined by *info*.
-    """
-    from os.path import join as joinpath, split as splitpath, splitext
-    basename = splitext(splitpath(info['filename'])[1])[0]
-    return joinpath(DLL_PATH, basename+'.so')
-
-
-def dll_model(kernel_module, dtype=None):
-    """
-    Load the compiled model defined by *kernel_module*.
-
-    Recompile if any files are newer than the model file.
-
-    *dtype* is ignored.  Compiled files are always double.
-
-    The DLL is not loaded until the kernel is called so models an
-    be defined without using too many resources.
-    """
-    import tempfile
-    from sasmodels import dll
-
-    source, info = make(kernel_module)
-    source_files = sources(info) + [info['filename']]
-    newest = max(os.path.getmtime(f) for f in source_files)
-    dllpath = dll_path(info)
-    if not os.path.exists(dllpath) or os.path.getmtime(dllpath)<newest:
-        # Replace with a proper temp file
-        srcfile = tempfile.mkstemp(suffix=".c",prefix="sas_"+info['name'])
-        open(srcfile, 'w').write(source)
-        os.system(COMPILE%(srcfile, dllpath))
-        ## comment the following to keep the generated c file
-        os.unlink(srcfile)
-    return dll.DllModel(dllpath, info)
-
-
-def opencl_model(kernel_module, dtype="single"):
-    """
-    Load the OpenCL model defined by *kernel_module*.
-
-    Access to the OpenCL device is delayed until the kernel is called
-    so models can be defined without using too many resources.
-    """
-    from sasmodels import gpu
-
-    source, info = make(kernel_module)
-    ## for debugging, save source to a .cl file, edit it, and reload as model
-    #open(modelname+'.cl','w').write(source)
-    #source = open(modelname+'.cl','r').read()
-    return gpu.GpuModel(source, info, dtype)
 
 
Index: sasmodels/gpu.py
===================================================================
--- sasmodels/gpu.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/gpu.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -25,6 +25,4 @@
 
 """
-import warnings
-
 import numpy as np
 import pyopencl as cl
@@ -32,6 +30,4 @@
 
 from . import gen
-
-from .gen import F32, F64
 
 F32_DEFS = """\
@@ -52,5 +48,18 @@
 # larger than necessary given that cost grows as npts^k where k is the number
 # of polydisperse parameters.
-MAX_LOOPS = 1024
+MAX_LOOPS = 2048
+
+def load_model(kernel_module, dtype="single"):
+    """
+    Load the OpenCL model defined by *kernel_module*.
+
+    Access to the OpenCL device is delayed until the kernel is called
+    so models can be defined without using too many resources.
+    """
+    source, info = gen.make(kernel_module)
+    ## for debugging, save source to a .cl file, edit it, and reload as model
+    open(info['name']+'.cl','w').write(source)
+    #source = open(info['name']+'.cl','r').read()
+    return GpuModel(source, info, dtype)
 
 ENV = None
@@ -103,8 +112,8 @@
     """
     dtype = np.dtype(dtype)
-    if dtype==F64 and not all(has_double(d) for d in context.devices):
+    if dtype==gen.F64 and not all(has_double(d) for d in context.devices):
         raise RuntimeError("Double precision not supported for devices")
 
-    header = F64_DEFS if dtype == F64 else F32_DEFS
+    header = F64_DEFS if dtype == gen.F64 else F32_DEFS
     # Note: USE_SINCOS makes the intel cpu slower under opencl
     if context.devices[0].type == cl.device_type.GPU:
@@ -158,5 +167,5 @@
     is an optional extension which may not be available on all devices.
     """
-    def __init__(self, source, info, dtype=F32):
+    def __init__(self, source, info, dtype=gen.F32):
         self.info = info
         self.source = source
@@ -221,5 +230,5 @@
     buffer will be released when the data object is freed.
     """
-    def __init__(self, q_vectors, dtype=F32):
+    def __init__(self, q_vectors, dtype=gen.F32):
         env = environment()
         self.nq = q_vectors[0].size
@@ -273,5 +282,5 @@
         env = environment()
         self.loops_b = [cl.Buffer(env.context, mf.READ_WRITE,
-                                  MAX_LOOPS*input.dtype.itemsize)
+                                  2*MAX_LOOPS*input.dtype.itemsize)
                         for _ in env.queues]
         self.res_b = [cl.Buffer(env.context, mf.READ_WRITE,
@@ -281,14 +290,15 @@
 
     def __call__(self, pars, pd_pars, cutoff=1e-5):
-        real = np.float32 if self.input.dtype == F32 else np.float64
+        real = np.float32 if self.input.dtype == gen.F32 else np.float64
         fixed = [real(p) for p in pars]
         cutoff = real(cutoff)
         loops = np.hstack(pd_pars)
         loops = np.ascontiguousarray(loops.T, self.input.dtype).flatten()
-        loops_N = [np.uint32(len(p[0])) for p in pd_pars]
+        Nloops = [np.uint32(len(p[0])) for p in pd_pars]
+        #print "loops",Nloops, loops
 
         #import sys; print >>sys.stderr,"opencl eval",pars
         #print "opencl eval",pars
-        if len(loops) > MAX_LOOPS:
+        if len(loops) > 2*MAX_LOOPS:
             raise ValueError("too many polydispersity points")
         device_num = 0
@@ -300,5 +310,5 @@
         #ctx = environment().context
         #loops_bi = cl.Buffer(ctx, mf.READ_ONLY | mf.COPY_HOST_PTR, hostbuf=loops)
-        args = self.input.q_buffers + [res_bi,loops_bi,loops_l,cutoff] + fixed + loops_N
+        args = self.input.q_buffers + [res_bi,loops_bi,loops_l,cutoff] + fixed + Nloops
         self.kernel(queuei, self.input.global_size, None, *args)
         cl.enqueue_copy(queuei, self.res, res_bi)
Index: sasmodels/models/capped_cylinder.c
===================================================================
--- sasmodels/models/capped_cylinder.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/capped_cylinder.c	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,149 @@
+real form_volume(real radius, real cap_radius, real length);
+real Iq(real q, real sld, real solvent_sld,
+    real radius, real cap_radius, real length);
+real Iqxy(real qx, real qy, real sld, real solvent_sld,
+    real radius, real cap_radius, real length, real theta, real phi);
+
+// Integral over a convex lens kernel for t in [h/R,1].  See the docs for
+// the definition of the function being integrated.
+//   q is the magnitude of the q vector.
+//   h is the length of the lens "inside" the cylinder.  This negative wrt the
+//       definition of h in the docs.
+//   cap_radius is the radius of the lens
+//   length is the cylinder length, or the separation between the lens halves
+//   alpha is the angle of the cylinder wrt q.
+real _cap_kernel(real q, real h, real cap_radius, real length,
+                 real sin_alpha, real cos_alpha);
+real _cap_kernel(real q, real h, real cap_radius, real length,
+                 real sin_alpha, real cos_alpha)
+{
+    // For speed, we are pre-calculating terms which are constant over the
+    // kernel.
+    const real upper = REAL(1.0);
+    const real lower = h/cap_radius; // integral lower bound
+    const real m = q*cos_alpha*cap_radius; // cos argument slope
+    const real b = q*cos_alpha*(REAL(0.5)*length-h); // cos argument intercept
+    const real qrst = q*sin_alpha*cap_radius; // Q*R*sin(theta)
+    real total = REAL(0.0);
+    for (int i=0; i<76 ;i++) {
+        // translate a point in [-1,1] to a point in [lower,upper]
+        //const real t = ( Gauss76Z[i]*(upper-lower) + upper + lower )/2.0;
+        const real t = REAL(0.5)*(Gauss76Z[i]*(upper-lower)+upper+lower);
+        const real radical = REAL(1.0) - t*t;
+        const real caparg = qrst*sqrt(radical); // cap bessel function arg
+        const real be = (caparg == REAL(0.0) ? REAL(0.5) : J1(caparg)/caparg);
+        const real Fq = cos(m*t + b) * radical * be;
+        total += Gauss76Wt[i] * Fq;
+    }
+    // translate dx in [-1,1] to dx in [lower,upper]
+    //const real form = (upper-lower)/2.0*total;
+    const real integral = REAL(0.5)*(upper-lower)*total;
+    return REAL(4.0)*M_PI*cap_radius*cap_radius*cap_radius*integral;
+}
+
+real form_volume(real radius, real cap_radius, real length)
+{
+    // cap radius should never be less than radius when this is called
+    // Note: cap volume = pi hc/6 * (3 a^2 + hc^2), where a is the cylinder
+    // radius and hc is the height of the cap.  Multiply by two for both ends.
+    // So:
+    //      cap V = pi hc (r^2 + hc^2/3)
+    //      cylinder V = pi r^2 L
+    //      V = cylinder V + cap V
+    //        = pi r^2 L + pi hc (r^2 + hc^2/3)
+    //        = pi * (r^2 (L+hc) + hc^3/3)
+    const real hc = cap_radius - sqrt(cap_radius*cap_radius - radius*radius);
+    return M_PI*(radius*radius*(length+hc) + REAL(0.333333333333333)*hc*hc*hc);
+}
+
+real Iq(real q,
+    real sld,
+    real solvent_sld,
+    real radius,
+    real cap_radius,
+    real length)
+{
+    real sn, cn; // slots to hold sincos function output
+
+    // Exclude invalid inputs.
+    if (cap_radius < radius) return REAL(-1.0);
+
+    const real lower = REAL(0.0);
+    const real upper = M_PI_2;
+    const real h = sqrt(cap_radius*cap_radius - radius*radius); // negative h
+    real total = REAL(0.0);
+    for (int i=0; i<76 ;i++) {
+        // translate a point in [-1,1] to a point in [lower,upper]
+        const real alpha= REAL(0.5)*(Gauss76Z[i]*(upper-lower) + upper + lower);
+        SINCOS(alpha, sn, cn);
+
+        const real cap_Fq = _cap_kernel(q, h, cap_radius, length, sn, cn);
+
+        // The following is CylKernel() / sin(alpha), but we are doing it in place
+        // to avoid sin(alpha)/sin(alpha) for alpha = 0.  It is also a teensy bit
+        // faster since we don't multiply and divide sin(alpha).
+        const real besarg = q*radius*sn;
+        const real siarg = REAL(0.5)*q*length*cn;
+        // lim_{x->0} J1(x)/x = 1/2,   lim_{x->0} sin(x)/x = 1
+        const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
+        const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
+        const real cyl_Fq = M_PI*radius*radius*length*REAL(2.0)*bj*si;
+
+        // Volume weighted average F(q)
+        const real Aq = cyl_Fq + cap_Fq;
+        total += Gauss76Wt[i] * Aq * Aq * sn; // sn for spherical coord integration
+    }
+    // translate dx in [-1,1] to dx in [lower,upper]
+    const real form = total * REAL(0.5)*(upper-lower);
+
+    // Multiply by contrast^2, normalize by cylinder volume and convert to cm-1
+    // NOTE that for this (Fournet) definition of the integral, one must MULTIPLY by Vcyl
+    // The additional volume factor is for polydisperse volume normalization.
+    const real s = (sld - solvent_sld);
+    return REAL(1.0e-4) * form * s * s; // form_volume(radius, cap_radius, length);
+}
+
+
+real Iqxy(real qx, real qy,
+    real sld,
+    real solvent_sld,
+    real radius,
+    real cap_radius,
+    real length,
+    real theta,
+    real phi)
+{
+    real sn, cn; // slots to hold sincos function output
+
+    // Exclude invalid inputs.
+    if (cap_radius < radius) return REAL(-1.0);
+
+    // Compute angle alpha between q and the cylinder axis
+    SINCOS(theta*M_PI_180, sn, cn);
+    // # The following correction factor exists in sasview, but it can't be
+    // # right, so we are leaving it out for now.
+    const real q = sqrt(qx*qx+qy*qy);
+    const real cos_val = cn*cos(phi*M_PI_180)*(qx/q) + sn*(qy/q);
+    const real alpha = acos(cos_val); // rod angle relative to q
+    SINCOS(alpha, sn, cn);
+
+    const real h = sqrt(cap_radius*cap_radius - radius*radius); // negative h
+    const real cap_Fq = _cap_kernel(q, h, cap_radius, length, sn, cn);
+
+    // The following is CylKernel() / sin(alpha), but we are doing it in place
+    // to avoid sin(alpha)/sin(alpha) for alpha = 0.  It is also a teensy bit
+    // faster since we don't multiply and divide sin(alpha).
+    const real besarg = q*radius*sn;
+    const real siarg = REAL(0.5)*q*length*cn;
+    // lim_{x->0} J1(x)/x = 1/2,   lim_{x->0} sin(x)/x = 1
+    const real bj = (besarg == REAL(0.0) ? REAL(0.5) : J1(besarg)/besarg);
+    const real si = (siarg == REAL(0.0) ? REAL(1.0) : sin(siarg)/siarg);
+    const real cyl_Fq = M_PI*radius*radius*length*REAL(2.0)*bj*si;
+
+    // Volume weighted average F(q)
+    const real Aq = cyl_Fq + cap_Fq;
+
+    // Multiply by contrast^2, normalize by cylinder volume and convert to cm-1
+    const real s = (sld - solvent_sld);
+    return REAL(1.0e-4) * Aq * Aq * s * s; // form_volume(radius, cap_radius, length);
+}
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/models/capped_cylinder.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,143 @@
+r"""
+Calculates the scattering from a cylinder with spherical section end-caps.
+This model simply becomes the `convex_lens`_ when the length of the cylinder
+$L=0$, that is, a sphereocylinder with end caps that have a radius larger
+than that of the cylinder and the center of the end cap radius lies within
+the cylinder. See the diagram for the details of the geometry and
+restrictions on parameter values.
+
+Definitions
+-----------
+
+The returned value is scaled to units of |cm^-1|\ |sr^-1|, absolute scale.
+
+The capped cylinder geometry is defined as
+
+.. image:: img/image112.JPG
+
+where $r$ is the radius of the cylinder. All other parameters are as defined
+in the diagram. Since the end cap radius $R \ge r$ and by definition for this
+geometry $h < 0$, $h$ is then defined by $r$ and $R$ as
+
+.. math::
+
+    h = - \sqrt{R^2 - r^2}
+
+The scattered intensity $I(q)$ is calculated as
+
+.. math::
+
+    I(q) = \frac{(\Delta \rho)^2}{V} left<A^2(q)\right>
+
+where the amplitude $A(q)$ is given as
+
+.. math::
+
+    A(Q) = \pi r^2L \frac{sin(Q(L/2) \cos \theta)}{Q(L/2) \cos \theta} \
+        \frac{2 J_1(Q r \sin \theta)}{Q r \sin \theta} \
+        + 4 \pi R^3 \int_{-h/R}^1{dt \cos [ Q cos\theta (Rt + h + L/2)] \
+        x (1-t^2)\frac{J_1[Q R \sin \theta (1-t^2)^{1/2}]}{Q R \sin \theta (1-t^2)^{1/2}
+
+The $\left< \ldots \right>$ brackets denote an average of the structure over
+all orientations. $\left< A^2(q)\right>$ is then the form factor, $P(q)$.
+The scale factor is equivalent to the volume fraction of cylinders, each of
+volume, $V$. Contrast is the difference of scattering length densities of
+the cylinder and the surrounding solvent.
+
+The volume of the capped cylinder is (with $h$ as a positive value here)
+
+.. math::
+
+    V = \pi r_c^2 L + \frac{2\pi}{3}(R-h)^2(2R + h)
+
+
+and its radius-of-gyration is
+
+    R_g^2 = \left[ \frac{12}{5}R^5 + R^4(6h+\frac{3}{2}L) \
+        + R^2(4h^2 + L^2 + 4Lh) + R^2(3Lh^2 + [frac{3}{2}L^2h) \
+        + \frac{2}{5}h^5 - \frac{1}{2}Lh^4 - \frac{1}{2}L^2h^3 \
+        + \frac{1}{4}L^3r^2 + \frac{3}{2}Lr^4\right] \
+        (4R^3 6R^2h - 2h^3 + 3r^2L)^{-1}
+
+
+**The requirement that $R \ge r$ is not enforced in the model! It is up to
+you to restrict this during analysis.**
+
+Figure :num:`figure #capped-cylinder-1d` shows the output produced by
+a running the 1D capped cylinder model, using *qmin* = 0.001 |Ang^-1|,
+*qmax* = 0.7 |Ang^-1| and  the default values of the parameters.
+
+.. _capped-cylinder-1d:
+
+.. figure:: img/image117.jpg
+
+    1D plot using the default values (w/256 data point).
+
+The 2D scattering intensity is calculated similar to the 2D cylinder model.
+Figure :num:`figure #capped-cylinder-2d` shows the output for $\theta=45^\circ$
+and $\phi=0^\circ$ with default values for the other parameters.
+
+.. _capped-cylinder-2d:
+
+.. figure:: img/image118.JPG
+
+    2D plot (w/(256X265) data points).
+
+.. figure:: img/image061.JPG
+
+    Definition of the angles for oriented 2D cylinders.
+
+.. figure:: img/image062.jpg
+
+    Examples of the angles for oriented pp against the detector plane.
+
+REFERENCE
+
+H Kaya, *J. Appl. Cryst.*, 37 (2004) 223-230
+
+H Kaya and N-R deSouza, *J. Appl. Cryst.*, 37 (2004) 508-509 (addenda and errata)
+"""
+from numpy import inf
+
+name = "capped_cylinder"
+title = "Right circular cylinder with spherical end caps and uniform SLD"
+description = """That is, a sphereocylinder
+	with end caps that have a radius larger than
+	that of the cylinder and the center of the
+	end cap radius lies within the cylinder.
+	Note: As the length of cylinder -->0,
+	it becomes a ConvexLens.
+	It must be that radius <(=) cap_radius.
+	[Parameters];
+	scale: volume fraction of spheres,
+	background:incoherent background,
+	radius: radius of the cylinder,
+	length: length of the cylinder,
+	cap_radius: radius of the semi-spherical cap,
+	sld: SLD of the capped cylinder,
+	solvent_sld: SLD of the solvent.
+"""
+
+parameters = [
+    #   [ "name", "units", default, [lower, upper], "type",
+    #     "description" ],
+    [ "sld", "1e-6/Ang^2", 4, [-inf,inf], "",
+      "Cylinder scattering length density" ],
+    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "",
+      "Solvent scattering length density" ],
+    [ "radius", "Ang",  20, [0, inf], "volume",
+      "Cylinder radius" ],
+    [ "cap_radius", "Ang", 20, [0, inf], "volume",
+      "Cap radius" ],
+    [ "length", "Ang",  400, [0, inf], "volume",
+      "Cylinder length" ],
+    [ "theta", "degrees", 60, [-inf, inf], "orientation",
+      "In plane angle" ],
+    [ "phi", "degrees", 60, [-inf, inf], "orientation",
+      "Out of plane angle" ],
+    ]
+
+source = [ "lib/J1.c", "lib/gauss76.c", "capped_cylinder.c" ]
+
+
+
